package common

import (
	"bytes"
	"encoding/base64"
	"errors"
	"oc-discovery/conf"
	"oc-discovery/models"
	"os"

	"cloud.o-forge.io/core/oc-lib/models/peer"
	"github.com/libp2p/go-libp2p/core/crypto"
	"github.com/libp2p/go-libp2p/core/pnet"
)

func VerifyPeer(peers []*peer.Peer, event models.Event) error {
	if len(peers) == 0 {
		return errors.New("no peer found")
	}
	p := peers[0]
	if p.Relation == peer.BLACKLIST { // if peer is blacklisted... quit...
		return errors.New("peer is blacklisted")
	}
	pubKey, err := PubKeyFromString(p.PublicKey) // extract pubkey from pubkey str
	if err != nil {
		return errors.New("pubkey is malformed")
	}
	data, err := event.ToRawByte()
	if err != nil {
		return err
	} // extract byte from raw event excluding signature.
	if ok, _ := pubKey.Verify(data, event.Signature); !ok { // then verify if pubkey sign this message...
		return errors.New("check signature failed")
	}
	return nil
}

func Sign(priv crypto.PrivKey, data []byte) ([]byte, error) {
	return priv.Sign(data)
}

func Verify(pub crypto.PubKey, data, sig []byte) (bool, error) {
	return pub.Verify(data, sig)
}

func LoadPSKFromFile() (pnet.PSK, error) {
	path := conf.GetConfig().PSKPath
	data, err := os.ReadFile(path)
	if err != nil {
		return nil, err
	}
	psk, err := pnet.DecodeV1PSK(bytes.NewReader(data))
	if err != nil {
		return nil, err
	}
	return psk, nil
}

func PubKeyFromString(s string) (crypto.PubKey, error) {
	data, err := base64.StdEncoding.DecodeString(s)
	if err != nil {
		return nil, err
	}

	return crypto.UnmarshalPublicKey(data)
}
